require 'test_helper'

class Gitmain::TextBlobTest < Minitest::Test
  def test_text
    setup_repository do |repository|
      blob = Gitmain::TextBlob.new(repository, '3245b20dc91de6cd85203c7184430a969689ac56')
      assert_equal 'Hello World.', blob.text
    end
  end

  def test_changed_attributes
    setup_repository do |repository|
      blob = Gitmain::TextBlob.new(repository, '3245b20dc91de6cd85203c7184430a969689ac56')
      assert_equal({}, blob.changed_attributes)
      blob.text = 'Hello Gitmain World!'
      assert_equal({ text: 'Hello World.' }, blob.changed_attributes)
    end
  end

  def test_setting_text
    setup_repository do |repository|
      blob = Gitmain::TextBlob.new(repository, '3245b20dc91de6cd85203c7184430a969689ac56')
      blob.text = 'Hello Gitmain World!'
      assert_equal 'Hello Gitmain World!', blob.text
    end
  end
end
